package sun.awt.windows;

import java.awt.Rectangle;
import java.awt.GraphicsDevice;
import java.awt.peer.RobotPeer;

final class WRobotPeer extends WObjectPeer implements RobotPeer
{
    WRobotPeer() {
        this.create();
    }
    
    WRobotPeer(GraphicsDevice graphicsDevice) {
        this.create();
    }
    
    private synchronized native void _dispose();
    
    @Override
    protected void disposeImpl() {
        this._dispose();
    }
    
    public native void create();
    
    public native void mouseMoveImpl(int p0, int p1);
    
    @Override
    public void mouseMove(int n, int n2) {
        this.mouseMoveImpl(n, n2);
    }
    
    @Override
    public native void mousePress(int p0);
    
    @Override
    public native void mouseRelease(int p0);
    
    @Override
    public native void mouseWheel(int p0);
    
    @Override
    public native void keyPress(int p0);
    
    @Override
    public native void keyRelease(int p0);
    
    @Override
    public int getRGBPixel(int x, int y) {
        return this.getRGBPixels(new Rectangle(x, y, 1, 1))[0];
    }
    
    @Override
    public int[] getRGBPixels(Rectangle rectangle) {
        int[] array = new int[rectangle.width * rectangle.height];
        this.getRGBPixels(rectangle.x, rectangle.y, rectangle.width, rectangle.height, array);
        return array;
    }
    
    private native void getRGBPixels(int p0, int p1, int p2, int p3, int[] p4);
}
